apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ sonarqube_name }}
  name: {{ sonarqube_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ sonarqube_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ sonarqube_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ sonarqube_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
    recreateParams:
      timeoutSeconds: 1800
  template:
    metadata:
      labels:
        name: {{ sonarqube_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
{% if k8s_flavor == 'openshift' and (ocp_major | int) > 3 %}
        tuned.openshift.io/elasticsearch: ""
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ sonarqube_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ sonarqube_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ sonarqube_name }}-admin
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: INSTALL_PLUGINS
{% if do_exporters %}
          value: "{{ sonarqube_prometheus_plugin }} {{ sonarqube_install_plugins | join(' ') }}"
        - name: REMOVE_PLUGINS
          value: sonar-prometheus-exporter-1.0.0
{% else %}
          value: "{{ sonarqube_install_plugins | join(' ') }}"
        - name: REMOVE_PLUGINS
          value: ""
{% endif %}
        - name: RESET_SSL
          value: "{{ 'true' if (sq_dc.resources | length > 0 and (sq_dc.resources[0].metadata.labels['pki.opsperator.io/has-ca'] | default('')) != (pki_set | join(','))) else '' }}"
        - name: SCANNER_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ sonarqube_name }}-scanner
        - name: SCANNER_USER
          valueFrom:
            secretKeyRef:
              key: username
              name: {{ sonarqube_name }}-scanner
        - name: SONAR_PRIVATE
          value: ""
        - name: SONAR_PROJECT
          value: ""
        - name: SONARQUBE_JDBC_PASSWORD
{% if sonarqube_db_type == 'postgres' %}
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ sonarqube_pg_name }}
        - name: SONARQUBE_JDBC_URL
          value: "jdbc:postgresql://{{ sonarqube_pg_name }}/{{ sonarqube_db_secret.resources[0].data['database-name'] | b64decode }}"
        - name: SONARQUBE_JDBC_USERNAME
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ sonarqube_pg_name }}
{% else %}
          value: ""
        - name: SONARQUBE_JDBC_URL
          value: ""
        - name: SONARQUBE_JDBC_USERNAME
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='sonarqube'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='sonarqube'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 58
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /api/system/status
            port: 9000
            scheme: HTTP
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
        name: sonarqube
        ports:
        - containerPort: 9000
        readinessProbe:
          httpGet:
            path: /api/system/status
            port: 9000
            scheme: HTTP
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: 4
        resources:
          limits:
            cpu: {{ sonarqube_cpu_limit }}
            memory: {{ sonarqube_memory_limit }}
          requests:
            cpu: {{ sonarqube_cpu_request }}
            memory: {{ sonarqube_memory_request }}
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 58
          initialDelaySeconds: 60
          periodSeconds: 30
          tcpSocket:
            port: 9000
{% endif %}
        volumeMounts:
{% if do_ldap or do_lemon %}
{% if k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /opt/sonarqube/conf
          name: conf
        - mountPath: /opt/sonarqube/data
          name: data
        - mountPath: /opt/sonarqube/data/es7
          name: temp
          subPath: es7
        - mountPath: /opt/sonarqube/logs
          name: temp
          subPath: logs
        - mountPath: /opt/sonarqube/temp
          name: temp
          subPath: tmp
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: ca-certificates
        - mountPath: /opt/jdk/lib/security
          name: temp
          subPath: empty
{% if (sq_dc.resources | length > 0 and (sq_dc.resources[0].metadata.labels['pki.opsperator.io/has-ca'] | default('')) != (pki_set | join(','))) %}
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: empty-too
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-infra
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
      terminationGracePeriodSeconds: 120
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ sonarqube_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if do_ldap %}
      - name: conf
        secret:
          defaultMode: 420
          secretName: {{ sonarqube_name }}
{% else %}
      - configMap:
          defaultMode: 420
          name: {{ sonarqube_name }}
        name: conf
{% endif %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ sonarqube_name }}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
      - emptyDir: {}
        name: temp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='sonarqube'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sonarqube
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sonarqube'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
